unit main; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SpiderCGI, SpiderAction, SpiderUtils, Math, jqgrid, htmltemplate;

type

  { TDataModule1 }

  TDataModule1 = class(TDataModule)
    sa_GetData: TSpiderAction;
    SpiderCGI1: TSpiderCGI;
    procedure DataModuleCreate(Sender: TObject);
    procedure sa_GetDataRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure SpiderCGI1Request(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  DataModule1: TDataModule1; 

implementation


{$R *.lfm}


{ TDataModule1 }

procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
     SpiderCGI1.Execute;
end;

procedure TDataModule1.sa_GetDataRequest(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
Var
  i: integer;
  Start, Page, Limit, Count, TotalPages: integer;
begin

  Count:= 10001;
  if Request.Query('rows') <> '' then
    Limit:= StrToInt(Request.Query('rows'))
  else
    Limit:= 0;

  if Request.Query('page') <> '' then
    Page:= StrToInt(Request.Query('page'))
  else
    Page:= 1;

  if (Count > 0) and (Limit > 0) then
    TotalPages:= ceil(Count/Limit)
  else
    TotalPages:= 0;

  if (Page > TotalPages) then
    Page:= TotalPages;

  Start:= Limit * Page - Limit;
  if Start < 0 Then Start:= 0;

  Response.ContentType:='Content-type: text/xml;charset=utf-8';
  Response.Add('<?xml version ="1.0" encoding="utf-8"?>');
  Response.Add('<rows>');
  Response.Add('  <page>' + IntToStr(page) + '</page>');
  Response.Add('  <total>' + IntToStr(TotalPages) + '</total>');
  Response.Add('  <records>' + IntToStr(Count) + '</records>');
  for i:= start to Limit + Start do
  begin
    Response.Add('    <row id = ''' + inttostr(i) + '''>');
    Response.Add('      <cell>ID' + inttostr(i) + '</cell>');
    Response.Add('      <cell>Debug: ' + 'Limit=' + IntToStr(Limit) + 'Start=' + IntToStr(Start) + '</cell>');
    Response.Add('    </row>');
  end;
  Response.Add('</rows>');
end;

procedure TDataModule1.SpiderCGI1Request(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
var
   JQGrid: TJQGrid;
   Template: THtmlTemplate;
begin
       Template:= THtmlTemplate.Create('jqdata/template.html');
       Template.Tags.Add('<!--jspath-->', '/js/');
       Template.Tags.Add('<!--csspath-->', '/jquerydata/');
       Template.Load;

       JQGrid:= TJQGrid.Create;
       JQGrid.Width:= 500;
       JQGrid.Rows:= 20;
       JQGrid.HtmlTableID:= 'list';
       JQGrid.Url:= '/provaCGI/JGrid.exe/GetData';
       With JQGrid.AddColumn Do
       begin
         Title:= 'Column 1';
         Name:= 'Col1';
         IsSortable:= true;
       end;
       With JQGrid.AddColumn Do
       begin
         Title:= 'Column 2';
         Name:= 'Col2';
         IsSortable:= false;
       end;
       Template.AddExtraJavaScript(JQGrid.Content);
       response.Add(Template.Content);
       Template.Free;
       JQGrid.Free;
end;

end.

